defmodule Lighthouse.Client.Commands.Console do
  use Riptide.Command

  def handle_call(%{action: "riptide.connect"}, from, state) do
    {:reply, 1, state}
  end

  def handle_call(%{action: "console.new"}, from, state) do
    key = "1"
    {:reply, key, Dynamic.put(state, [:consoles, key], [])}
  end

  def handle_call(
        %{action: "console.execute", body: %{"console" => key, "code" => code}},
        from,
        state
      ) do
    vars = Dynamic.get(state, [:consoles, key], [])

    try do
      {result, vars} = Code.eval_string(code, vars)
      {:reply, inspect(result, pretty: true), Dynamic.put(state, [:consoles, key], vars)}
    rescue
      e -> {:reply, inspect(e, pretty: true), state}
    end
  end

  def handle_call(%{action: "console.execute", body: code}, from, state) do
    try do
      {result, _} = Code.eval_string(code, [])
      {:reply, inspect(result, pretty: true), state}
    rescue
      e -> {:error, inspect(e, pretty: true), state}
    end
  end

  def handle_info(:connect, _from, state) do
    {:noreply, state}
  end
end
